/* Copyright (c) 2020 Alaskan Emily, Transnat Games
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

/*****************************************************************************/
/* Contains default configuration.
 * This is only meant for internal use! 
 */

#ifndef REJOY_CONFIG_H
#define REJOY_CONFIG_H
#pragma once

/*****************************************************************************/
/* These aren't actually strict values, but some backends (such as DInput)
 * require us to tell them the max number of elements we want. These are chosen
 * to be about double what we would expect any controller to have.
 */
#ifndef REJOY_MAX_AXES
#define REJOY_MAX_AXES 8
#endif

/*****************************************************************************/

#ifndef REJOY_MAX_POVS
#define REJOY_MAX_POVS 4
#endif

/*****************************************************************************/

#ifndef REJOY_MAX_BUTTONS
#define REJOY_MAX_BUTTONS 64
#endif

/*****************************************************************************/

#ifndef REJOY_GAMEPAD_NAME_LEN
#define REJOY_GAMEPAD_NAME_LEN 64
#endif

/*****************************************************************************/

#endif /* REJOY_CONFIG_H */
